<?xml version="1.0"?>

<PropertyList>
    <name>flight-planner</name>
    <layout>vbox</layout>
    <resizable>true</resizable>

    <nasal>
        <open><![CDATA[
            var dlg = props.globals.getNode("/sim/gui/dialogs/flight-planner", 1);
            var dlg_node = cmdarg();

            var dir = getprop("/sim/fg-home") ~ "/Export";

            var tab = dlg.getNode("tab", 1);
            dlg.getNode("tabs", 1);
            if (tab.getValue() == nil) { tab.setIntValue(1); }
            var tabs_restored = dlg.getNode("tabs_restored", 1);
            var tabs = [];
            append(tabs, dlg.getNode("tabs").getNode("tab"), dlg.getNode("tabs").getNode("tab[1]", 1), dlg.getNode("tabs").getNode("tab[2]", 1), dlg.getNode("tabs").getNode("tab[3]", 1));
            ############ See additional init in the end of the OPEN section

            var selection_wpt = dlg.getNode("selection_wpt", 1);
            selection_wpt.setIntValue(-1);
            var selection_srch = dlg.getNode("selection_srch", 1);
            selection_srch.setIntValue(-1);

            var input = dlg.getNode("input", 1);
            input.setValue("");
            var units = dlg.getNode("units", 1);
            if (units.getValue() == nil) { units.setValue("m/Km"); }
            var units_set = dlg.getNode("units_set", 1);
            units_set.getChild("value", 0, 1).setValue("m/Km");
            units_set.getChild("value", 1, 1).setValue("ft/Nm");
            var baro = dlg.getNode("baro", 1);
            if (baro.getValue() == nil) { baro.setValue("QNH"); }
            var baros = dlg.getNode("baros", 1);
            baros.getChild("value", 0, 1).setValue("QNH");
            baros.getChild("value", 1, 1).setValue("QFE");

            var list_wpt = dlg_node.getNode("group[5]").getNode("list");
            var list_srch = dlg_node.getNode("group[8]").getNode("list");

            var route = dlg.getNode("route", 1);
            var search = dlg.getNode("search", 1);
            var temp_fp = dlg.getNode("temp_fp", 1);

            var search_for_ils = dlg.getNode("search_for_ils", 1);
            if (search_for_ils.getValue() == nil) { search_for_ils.setBoolValue(1); }

            var dep = dlg.getNode("departure", 1);
            var dep_ap_ghost = airportinfo();
            var dep_ap = dep.getNode("airport", 1);
            if (dep_ap.getValue() == nil) { dep_ap.setValue(""); }
            else { dep_ap_ghost = airportinfo(dep_ap.getValue()); }
            var dep_ap_name = dep.getNode("name", 1);
            if (dep_ap_name.getValue() == nil) { dep_ap_name.setValue(""); }
            var dep_runway = dep.getNode("runway", 1);
            if (dep_runway.getValue() == nil) { dep_runway.setValue(""); }
            var dep_runways = dep.getNode("runways", 1);
            var dep_route = dep.getNode("route", 1);
            var dest = dlg.getNode("destination", 1);
            var dest_ap_ghost = airportinfo();
            var dest_ap = dest.getNode("airport", 1);
            if (dest_ap.getValue() == nil) { dest_ap.setValue(""); }
            else { dest_ap_ghost = airportinfo(dest_ap.getValue()); }
            var dest_ap_name = dest.getNode("name", 1);
            if (dest_ap_name.getValue() == nil) { dest_ap_name.setValue(""); }
            var dest_runway = dest.getNode("runway", 1);
            if (dest_runway.getValue() == nil) { dest_runway.setValue(""); }
            var dest_runways = dest.getNode("runways", 1);
            var dest_route = dest.getNode("route", 1);

            var cruise_altitude = dlg.getNode("cruise_altitude", 1);
            if (cruise_altitude.getValue() == nil) { cruise_altitude.setDoubleValue(0.0); }

            var dist_node = dlg.getNode("dist", 1);



            var updateRoute = func() {
                list_wpt.removeChildren("value");

                var point1 = geo.Coord.new();
                var point2 = geo.Coord.new();
                var first_wp_present = 0;
                var rte_dist = 0;

                var i = 0;

                if (dep_ap_name.getValue() != "") {
                    var wp = list_wpt.getChild("value", i, 1);
                    var descr = "     ";
                    if (i < 100) { descr = sprintf("%s0", descr); }
                    if (i < 10) { descr = sprintf("%s0", descr); }
                    descr = sprintf("%s%d  %s-%s   (%s)", descr, i, dep_ap.getValue(), dep_runway.getValue(), dep_ap_name.getValue());
                    wp.setValue(descr);

                    first_wp_present = 1;
                    point1.set_latlon(airportinfo(dep_ap.getValue()).lat, airportinfo(dep_ap.getValue()).lon);
                }
                i += 1;

                foreach (var n; dep_route.getChildren("wp")) {
                    var wp = list_wpt.getChild("value", i, 1);
                    var descr = "|||   ";
                    if (i < 100) { descr = sprintf("%s0", descr); }
                    if (i < 10) { descr = sprintf("%s0", descr); }
                    descr = sprintf("%s%d  %s", descr, i, n.getNode("ident").getValue());
                    if (n.getNode("name").getValue() != "") { descr = sprintf("%s   (%s)", descr, n.getNode("name").getValue()); }
                    if (n.getNode("alt").getValue() > -2000) {
                        if (units.getValue() == "m/Km") { descr = sprintf("%s   @%.0f", descr, n.getNode("alt").getValue()); }
                        if (units.getValue() == "ft/Nm") { descr = sprintf("%s   @%.0f", descr, n.getNode("alt").getValue() * M2FT); }
                    }
                    wp.setValue(descr);

                    if(first_wp_present) {
                        point2.set_latlon(n.getNode("lat").getValue(), n.getNode("lon").getValue());
                        rte_dist += point1.distance_to(point2);
                        point1.set_latlon(n.getNode("lat").getValue(), n.getNode("lon").getValue());
                    }
                    else {
                        first_wp_present = 1;
                        point1.set_latlon(n.getNode("lat").getValue(), n.getNode("lon").getValue());
                    }

                    i += 1;
                }

                foreach (var n; route.getChildren("wp")) {
                    var wp = list_wpt.getChild("value", i, 1);
                    var descr = "     ";
                    if (i < 100) { descr = sprintf("%s0", descr); }
                    if (i < 10) { descr = sprintf("%s0", descr); }
                    descr = sprintf("%s%d  %s", descr, i, n.getNode("ident").getValue());
                    if (n.getNode("name").getValue() != "") { descr = sprintf("%s   (%s)", descr, n.getNode("name").getValue()); }
                    if (n.getNode("alt").getValue() > -2000) {
                        descr = sprintf("%s   @%.0f", descr, n.getNode("alt").getValue());
                    }
                    wp.setValue(descr);

                    if(first_wp_present) {
                        point2.set_latlon(n.getNode("lat").getValue(), n.getNode("lon").getValue());
                        rte_dist += point1.distance_to(point2);
                        point1.set_latlon(n.getNode("lat").getValue(), n.getNode("lon").getValue());
                    }
                    else {
                        first_wp_present = 1;
                        point1.set_latlon(n.getNode("lat").getValue(), n.getNode("lon").getValue());
                    }

                    i += 1;
                }

                foreach (var n; dest_route.getChildren("wp")) {
                    var wp = list_wpt.getChild("value", i, 1);
                    var descr = "|||   ";
                    if (i < 100) { descr = sprintf("%s0", descr); }
                    if (i < 10) { descr = sprintf("%s0", descr); }
                    descr = sprintf("%s%d  %s", descr, i, n.getNode("ident").getValue());
                    if (n.getNode("name").getValue() != "") { descr = sprintf("%s   (%s)", descr, n.getNode("name").getValue()); }
                    if (n.getNode("alt").getValue() > -2000) {
                        if (units.getValue() == "m/Km") { descr = sprintf("%s   @%.0f", descr, n.getNode("alt").getValue()); }
                        if (units.getValue() == "ft/Nm") { descr = sprintf("%s   @%.0f", descr, n.getNode("alt").getValue() * M2FT); }
                    }
                    wp.setValue(descr);

                    if(first_wp_present) {
                        point2.set_latlon(n.getNode("lat").getValue(), n.getNode("lon").getValue());
                        rte_dist += point1.distance_to(point2);
                        point1.set_latlon(n.getNode("lat").getValue(), n.getNode("lon").getValue());
                    }
                    else {
                        first_wp_present = 1;
                        point1.set_latlon(n.getNode("lat").getValue(), n.getNode("lon").getValue());
                    }

                    i += 1;
                }

                if (dest_ap_name.getValue() != "") {
                    var wp = list_wpt.getChild("value", i, 1);
                    var descr = "     ";
                    if (i < 100) { descr = sprintf("%s0", descr); }
                    if (i < 10) { descr = sprintf("%s0", descr); }
                    descr = sprintf("%s%d  %s-%s   (%s)", descr, i, dest_ap.getValue(), dest_runway.getValue(), dest_ap_name.getValue());
                    wp.setValue(descr);

                    if(first_wp_present) {
                        point2.set_latlon(airportinfo(dest_ap.getValue()).lat, airportinfo(dest_ap.getValue()).lon);
                        rte_dist += point1.distance_to(point2);
                    }
                }

                if (units.getValue() == "m/Km") {
                    dist_node.setValue(sprintf("%d Km", rte_dist / 1000));
                }
                else {
                    dist_node.setValue(sprintf("%d Nm", rte_dist * M2NM));
                }

                gui.dialog_update("flight-planner");
            }

            var updateSearch = func() {
                list_srch.removeChildren("value");

                var i = 0;

                foreach (var n; search.getChildren("wp")) {
                    var wp = list_srch.getChild("value", i, 1);
                    var descr = sprintf("  %s", n.getNode("ident").getValue());
                    if (n.getNode("name").getValue() != "") { descr = sprintf("%s   (%s)", descr, n.getNode("name").getValue()); }
                    if (n.getNode("alt").getValue() > -2000) {
                        descr = sprintf("%s   @%.0f", descr, n.getNode("alt").getValue());
                    }
                    wp.setValue(descr);

                    i += 1;
                }

                gui.dialog_update("flight-planner");
            }

            var updateDeparture = func() {
                dep_route.removeAllChildren();
                dep_runways.removeAllChildren();
                dep_runway.setValue("");
                dep_ap_name.setValue("");

                if (dep_ap.getValue() != "") {
                    dep_ap.setValue(string.uc(dep_ap.getValue()));
                    dep_ap_ghost = airportinfo(dep_ap.getValue());
                    if (dep_ap_ghost != nil) {
                        dep_ap_name.setValue(dep_ap_ghost.name);
                        foreach (var n; keys(dep_ap_ghost.runways)) {
                            dep_runways.addChild("value").setValue(n);
                            dep_runway.setValue(n);
                        }
                    }
                }

                gui.dialog_update("flight-planner");
                updateRoute();
            }

            var updateArrival = func() {
                dest_route.removeAllChildren();
                dest_runways.removeAllChildren();
                dest_runway.setValue("");
                dest_ap_name.setValue("");

                if (dest_ap.getValue() != "") {
                    dest_ap.setValue(string.uc(dest_ap.getValue()));
                    dest_ap_ghost = airportinfo(dest_ap.getValue());
                    if (dest_ap_ghost != nil) {
                        dest_ap_name.setValue(dest_ap_ghost.name);
                        foreach (var n; keys(dest_ap_ghost.runways)) {
                            dest_runways.addChild("value").setValue(n);
                            dest_runway.setValue(n);
                        }
                    }
                }

                gui.dialog_update("flight-planner");
                updateRoute();
            }

            var tab_load = func(next) {
                tabs[tab.getValue()].getNode("cruise_altitude").setDoubleValue(cruise_altitude.getValue());
                tabs[tab.getValue()].getNode("departure").getNode("airport").setValue(dep_ap.getValue());
                tabs[tab.getValue()].getNode("departure").getNode("runway").setValue(dep_runway.getValue());
                tabs[tab.getValue()].getNode("destination").getNode("airport").setValue(dest_ap.getValue());
                tabs[tab.getValue()].getNode("destination").getNode("runway").setValue(dest_runway.getValue());
                tabs[tab.getValue()].getNode("departure").getNode("route").removeAllChildren();
                foreach(var n; dep_route.getChildren()) {
                    var wp = tabs[tab.getValue()].getNode("departure").getNode("route").addChild("wp");
                    wp.addChild("ident").setValue(n.getNode("ident").getValue());
                    wp.addChild("name").setValue(n.getNode("name").getValue());
                    wp.addChild("alt").setValue(n.getNode("alt").getValue());
                    wp.addChild("lat").setValue(n.getNode("lat").getValue());
                    wp.addChild("lon").setValue(n.getNode("lon").getValue());
                }
                tabs[tab.getValue()].getNode("route").removeAllChildren();
                foreach(var n; route.getChildren()) {
                    var wp = tabs[tab.getValue()].getNode("route").addChild("wp");
                    wp.addChild("ident").setValue(n.getNode("ident").getValue());
                    wp.addChild("name").setValue(n.getNode("name").getValue());
                    wp.addChild("alt").setValue(n.getNode("alt").getValue());
                    wp.addChild("lat").setValue(n.getNode("lat").getValue());
                    wp.addChild("lon").setValue(n.getNode("lon").getValue());
                }
                tabs[tab.getValue()].getNode("destination").getNode("route").removeAllChildren();
                foreach(var n; dest_route.getChildren()) {
                    var wp = tabs[tab.getValue()].getNode("destination").getNode("route").addChild("wp");
                    wp.addChild("ident").setValue(n.getNode("ident").getValue());
                    wp.addChild("name").setValue(n.getNode("name").getValue());
                    wp.addChild("alt").setValue(n.getNode("alt").getValue());
                    wp.addChild("lat").setValue(n.getNode("lat").getValue());
                    wp.addChild("lon").setValue(n.getNode("lon").getValue());
                }

                cruise_altitude.setDoubleValue(tabs[next].getNode("cruise_altitude").getValue());
                dep_ap.setValue(tabs[next].getNode("departure").getNode("airport").getValue());
                updateDeparture();
                dep_runway.setValue(tabs[next].getNode("departure").getNode("runway").getValue());
                dest_ap.setValue(tabs[next].getNode("destination").getNode("airport").getValue());
                updateArrival();
                dest_runway.setValue(tabs[next].getNode("destination").getNode("runway").getValue());
                dep_route.removeAllChildren();
                foreach(var n; tabs[next].getNode("departure").getNode("route").getChildren()) {
                    var wp = dep_route.addChild("wp");
                    wp.addChild("ident").setValue(n.getNode("ident").getValue());
                    wp.addChild("name").setValue(n.getNode("name").getValue());
                    wp.addChild("alt").setValue(n.getNode("alt").getValue());
                    wp.addChild("lat").setValue(n.getNode("lat").getValue());
                    wp.addChild("lon").setValue(n.getNode("lon").getValue());
                }
                route.removeAllChildren();
                foreach(var n; tabs[next].getNode("route").getChildren()) {
                    var wp = route.addChild("wp");
                    wp.addChild("ident").setValue(n.getNode("ident").getValue());
                    wp.addChild("name").setValue(n.getNode("name").getValue());
                    wp.addChild("alt").setValue(n.getNode("alt").getValue());
                    wp.addChild("lat").setValue(n.getNode("lat").getValue());
                    wp.addChild("lon").setValue(n.getNode("lon").getValue());
                }
                dest_route.removeAllChildren();
                foreach(var n; tabs[next].getNode("destination").getNode("route").getChildren()) {
                    var wp = dest_route.addChild("wp");
                    wp.addChild("ident").setValue(n.getNode("ident").getValue());
                    wp.addChild("name").setValue(n.getNode("name").getValue());
                    wp.addChild("alt").setValue(n.getNode("alt").getValue());
                    wp.addChild("lat").setValue(n.getNode("lat").getValue());
                    wp.addChild("lon").setValue(n.getNode("lon").getValue());
                }

                tabs[tab.getValue()].getNode("selected").setValue(0);
                tabs[next].getNode("selected").setValue(1);

                tab.setIntValue(next);
                gui.dialog_update("flight-planner");
                updateRoute();
            }

            var generate_sid = func() {
                dep_route.removeAllChildren();

                var pos_dep = geo.Coord.new().set_latlon(dep_ap_ghost.runways[dep_runway.getValue()].lat, dep_ap_ghost.runways[dep_runway.getValue()].lon);
                var pos_dest = geo.Coord.new().set_latlon(dest_ap_ghost.runways[dest_runway.getValue()].lat, dest_ap_ghost.runways[dest_runway.getValue()].lon);
                var hdg_dep = dep_ap_ghost.runways[dep_runway.getValue()].heading;
                var elev_dep = dep_ap_ghost.elevation;
                var leg_crs = math.fmod(pos_dep.course_to(pos_dest) - hdg_dep + 540, 360) - 180;
                if (leg_crs < 45 and leg_crs > -45) { leg_crs = 0; }
                else if (leg_crs < 90 and leg_crs > -90) { leg_crs = 1 * leg_crs/math.abs(leg_crs); }
                else if (leg_crs < 135 and leg_crs > -135) { leg_crs = 2 * leg_crs/math.abs(leg_crs); }
                else { leg_crs = 3 * leg_crs/math.abs(leg_crs); }

                pos_dep.apply_course_distance(hdg_dep, 5556 + dep_ap_ghost.runways[dep_runway.getValue()].length);
                var wp = dep_route.addChild("wp");
                wp.addChild("ident").setValue(sprintf("%s-3", dep_runway.getValue()));
                wp.addChild("name").setValue("");
                if (baro.getValue() == "QNH") { wp.addChild("alt").setDoubleValue(elev_dep + 1100); }
                if (baro.getValue() == "QFE") { wp.addChild("alt").setDoubleValue(1100); }
                wp.addChild("lat").setDoubleValue(pos_dep.lat());
                wp.addChild("lon").setDoubleValue(pos_dep.lon());

                pos_dep.apply_course_distance(hdg_dep, 5556);
                wp = dep_route.addChild("wp");
                wp.addChild("ident").setValue(sprintf("%s-6", dep_runway.getValue()));
                wp.addChild("name").setValue("");
                if (baro.getValue() == "QNH") { wp.addChild("alt").setDoubleValue(elev_dep + 2000); }
                if (baro.getValue() == "QFE") { wp.addChild("alt").setDoubleValue(2000); }
                wp.addChild("lat").setDoubleValue(pos_dep.lat());
                wp.addChild("lon").setDoubleValue(pos_dep.lon());

                wp = dep_route.addChild("wp");
                wp.addChild("ident").setValue("DEP-3");
                wp.addChild("name").setValue("");
                wp.addChild("alt").setDoubleValue(-9999);
                wp.addChild("lat").setDoubleValue(pos_dep.lat());
                wp.addChild("lon").setDoubleValue(pos_dep.lon());

                for (var i = 0; i < math.abs(leg_crs); i += 1) {
                    hdg_dep = math.fmod(hdg_dep + 45 * leg_crs/math.abs(leg_crs) + 360, 360);
                    pos_dep.apply_course_distance(hdg_dep, 5000);
                    wp = dep_route.addChild("wp");
                    wp.addChild("ident").setValue(sprintf("DEP-%d", 4 + i));
                    wp.addChild("name").setValue("");
                    wp.addChild("alt").setDoubleValue(-9999);
                    wp.addChild("lat").setDoubleValue(pos_dep.lat());
                    wp.addChild("lon").setDoubleValue(pos_dep.lon());
                }

                gui.dialog_update("flight-planner");
                updateRoute();
            }

            var generate_approach = func() {
                dest_route.removeAllChildren();

                var pos_dep = geo.Coord.new().set_latlon(dep_ap_ghost.runways[dep_runway.getValue()].lat, dep_ap_ghost.runways[dep_runway.getValue()].lon);
                var pos_dest = geo.Coord.new().set_latlon(dest_ap_ghost.runways[dest_runway.getValue()].lat, dest_ap_ghost.runways[dest_runway.getValue()].lon);
                var hdg_dest = math.fmod(dest_ap_ghost.runways[dest_runway.getValue()].heading + 180, 360);
                var elev_dest = dest_ap_ghost.elevation;
                var leg_crs = math.fmod(pos_dest.course_to(pos_dep) - hdg_dest + 540, 360) - 180;
                if (leg_crs < 45 and leg_crs > -45) { leg_crs = 0; }
                else if (leg_crs < 90 and leg_crs > -90) { leg_crs = 1 * leg_crs/math.abs(leg_crs); }
                else if (leg_crs < 135 and leg_crs > -135) { leg_crs = 2 * leg_crs/math.abs(leg_crs); }
                else { leg_crs = 3 * leg_crs/math.abs(leg_crs); }

                pos_dest.apply_course_distance(hdg_dest, 22200);
                for (var i = 0; i < math.abs(leg_crs); i += 1) {
                    hdg_dest = math.fmod(hdg_dest + 45 * leg_crs/math.abs(leg_crs) + 360, 360);
                    pos_dest.apply_course_distance(hdg_dest, 5000);
                }
                hdg_dest = math.fmod(hdg_dest + 180, 360);
                for (var i = 3 + math.abs(leg_crs); i > 3; i -= 1) {
                    wp = dest_route.addChild("wp");
                    wp.addChild("ident").setValue(sprintf("APP-%d", i));
                    wp.addChild("name").setValue("");
                    if (baro.getValue() == "QNH") { wp.addChild("alt").setDoubleValue(elev_dest + 1500); }
                    if (baro.getValue() == "QFE") { wp.addChild("alt").setDoubleValue(1500); }
                    wp.addChild("lat").setDoubleValue(pos_dest.lat());
                    wp.addChild("lon").setDoubleValue(pos_dest.lon());
                    pos_dest.apply_course_distance(hdg_dest, 5000);
                    hdg_dest = math.fmod(hdg_dest - 45 * leg_crs/math.abs(leg_crs) + 360, 360);
                }

                wp = dest_route.addChild("wp");
                wp.addChild("ident").setValue(sprintf("%s-12", dest_runway.getValue()));
                wp.addChild("name").setValue("");
                if (baro.getValue() == "QNH") { wp.addChild("alt").setDoubleValue(elev_dest + 1500); }
                if (baro.getValue() == "QFE") { wp.addChild("alt").setDoubleValue(1500); }
                wp.addChild("lat").setDoubleValue(pos_dest.lat());
                wp.addChild("lon").setDoubleValue(pos_dest.lon());

                hdg_dest = math.fmod(dest_ap_ghost.runways[dest_runway.getValue()].heading + 180, 360);
                pos_dest.set_latlon(dest_ap_ghost.runways[dest_runway.getValue()].lat, dest_ap_ghost.runways[dest_runway.getValue()].lon).apply_course_distance(hdg_dest, 14800);
                wp = dest_route.addChild("wp");
                wp.addChild("ident").setValue(sprintf("%s-8", dest_runway.getValue()));
                wp.addChild("name").setValue("");
                if (baro.getValue() == "QNH") { wp.addChild("alt").setDoubleValue(elev_dest + 750); }
                if (baro.getValue() == "QFE") { wp.addChild("alt").setDoubleValue(750); }
                wp.addChild("lat").setDoubleValue(pos_dest.lat());
                wp.addChild("lon").setDoubleValue(pos_dest.lon());

                pos_dest.set_latlon(dest_ap_ghost.runways[dest_runway.getValue()].lat, dest_ap_ghost.runways[dest_runway.getValue()].lon).apply_course_distance(hdg_dest, 11600);
                wp = dest_route.addChild("wp");
                wp.addChild("ident").setValue(sprintf("%s-GS", dest_runway.getValue()));
                wp.addChild("name").setValue("");
                if (baro.getValue() == "QNH") { wp.addChild("alt").setDoubleValue(elev_dest + 750); }
                if (baro.getValue() == "QFE") { wp.addChild("alt").setDoubleValue(750); }
                wp.addChild("alt").setDoubleValue(elev_dest + 750);
                wp.addChild("lat").setDoubleValue(pos_dest.lat());
                wp.addChild("lon").setDoubleValue(pos_dest.lon());
            
                gui.dialog_update("flight-planner");
                updateRoute();
            }

            var clear = func() {
                route.removeAllChildren();
                dep_route.removeAllChildren();
                dest_route.removeAllChildren();

                selection_wpt.setIntValue(-1);
                gui.dialog_update("flight-planner");
                updateRoute();
            }

            var remove = func() {
                var prev = 0;

                if (dep_ap_name != "") { prev = 1; }
                if (selection_wpt.getValue() < prev + size(dep_route.getChildren()) and selection_wpt.getValue() >= prev) {
                    #print("Departure");
                    selection_wpt.setValue(selection_wpt.getValue() - prev);
                    var i = 0;
                    for (i = selection_wpt.getValue(); i < size(dep_route.getChildren()) - 1; i += 1) {
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("alt").setValue(dep_route.getNode(sprintf("wp[%d]", i + 1)).getNode("alt").getValue());
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("ident").setValue(dep_route.getNode(sprintf("wp[%d]", i + 1)).getNode("ident").getValue());
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("name").setValue(dep_route.getNode(sprintf("wp[%d]", i + 1)).getNode("name").getValue());
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("lat").setValue(dep_route.getNode(sprintf("wp[%d]", i + 1)).getNode("lat").getValue());
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("lon").setValue(dep_route.getNode(sprintf("wp[%d]", i + 1)).getNode("lon").getValue());
                    }
                    dep_route.getNode(sprintf("wp[%d]", i)).remove();
                }
                else {
                    prev += size(dep_route.getChildren());
                    if (selection_wpt.getValue() < prev + size(route.getChildren()) and selection_wpt.getValue() >= prev) {
                        #print("Route");
                        selection_wpt.setValue(selection_wpt.getValue() - prev);
                        var i = 0;
                        for (i = selection_wpt.getValue(); i < size(route.getChildren()) - 1; i += 1) {
                            route.getNode(sprintf("wp[%d]", i)).getNode("alt").setValue(route.getNode(sprintf("wp[%d]", i + 1)).getNode("alt").getValue());
                            route.getNode(sprintf("wp[%d]", i)).getNode("ident").setValue(route.getNode(sprintf("wp[%d]", i + 1)).getNode("ident").getValue());
                            route.getNode(sprintf("wp[%d]", i)).getNode("name").setValue(route.getNode(sprintf("wp[%d]", i + 1)).getNode("name").getValue());
                            route.getNode(sprintf("wp[%d]", i)).getNode("lat").setValue(route.getNode(sprintf("wp[%d]", i + 1)).getNode("lat").getValue());
                            route.getNode(sprintf("wp[%d]", i)).getNode("lon").setValue(route.getNode(sprintf("wp[%d]", i + 1)).getNode("lon").getValue());
                        }
                        route.getNode(sprintf("wp[%d]", i)).remove();
                    }
                    else {
                        prev += size(route.getChildren());
                        if (selection_wpt.getValue() < prev + size(dest_route.getChildren()) and selection_wpt.getValue() >= prev) {
                            #print("Approach");
                            selection_wpt.setValue(selection_wpt.getValue() - prev);
                            var i = 0;
                            for (i = selection_wpt.getValue(); i < size(dest_route.getChildren()) - 1; i += 1) {
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("alt").setValue(dest_route.getNode(sprintf("wp[%d]", i + 1)).getNode("alt").getValue());
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("ident").setValue(dest_route.getNode(sprintf("wp[%d]", i + 1)).getNode("ident").getValue());
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("name").setValue(dest_route.getNode(sprintf("wp[%d]", i + 1)).getNode("name").getValue());
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("lat").setValue(dest_route.getNode(sprintf("wp[%d]", i + 1)).getNode("lat").getValue());
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("lon").setValue(dest_route.getNode(sprintf("wp[%d]", i + 1)).getNode("lon").getValue());
                            }
                            dest_route.getNode(sprintf("wp[%d]", i)).remove();
                        }
                    }
                }

                selection_wpt.setIntValue(-1);
                #selection_wpt.setValue(selection_wpt.getValue() + prev);

                gui.dialog_update("flight-planner");
                updateRoute();
            }

            var pushToRM = func() {
                var fp = props.globals.getNode("/autopilot/route-manager");

                flightplan().cleanPlan();
                fp.getNode("departure").getNode("airport").setValue(dep_ap.getValue());
                fp.getNode("departure").getNode("runway").setValue(dep_runway.getValue());
                fp.getNode("destination").getNode("airport").setValue("");

                foreach (var n; dep_route.getChildren("wp")) {
                    var fp_route =  fp.getNode("route");
                    var wp = createWP(n.getNode("lat").getValue(), n.getNode("lon").getValue(), n.getNode("ident").getValue());
                    flightplan().appendWP(wp);
                }

                foreach (var n; route.getChildren("wp")) {
                    var fp_route =  fp.getNode("route");
                    var wp = createWP(n.getNode("lat").getValue(), n.getNode("lon").getValue(), n.getNode("ident").getValue());
                    flightplan().appendWP(wp);
                }

                foreach (var n; dest_route.getChildren("wp")) {
                    var fp_route =  fp.getNode("route");
                    var wp = createWP(n.getNode("lat").getValue(), n.getNode("lon").getValue(), n.getNode("ident").getValue());
                    flightplan().appendWP(wp);
                }

                fp.getNode("destination").getNode("airport").setValue(dest_ap.getValue());
                fp.getNode("destination").getNode("runway").setValue(dest_runway.getValue());

                gui.dialog_update("flight-planner");
            }

            var pullFromRm = func() {
                var path = dir ~ "/temp_fp.xml";
                var routem = props.globals.getNode("/autopilot/route-manager", 1);
                var cmd = routem.getNode("input", 1);
                routem.getNode("file-path", 1).setValue(path);
                cmd.setValue("@save");
                
                LoadTempFlightplan();
            }

            var do_search = func() {
                if (input.getValue() != "") {
                    search.removeAllChildren();

                    var point = split(" ", input.getValue())[0];
                    var alt = -9999.9;
                    var offset_hdg = 0.0;
                    var offset_dist = 0.0;
                    if (size(split("@", point)) > 1) {
                        alt = num(split("@", point)[1]);
                        point = split("@", point)[0];
                    }
                    if (size(split("/", point)) == 3) {
                        offset_hdg = num(split("/", point)[1]);
                        if (units.getValue() == "m/Km") { offset_dist = num(split("/", point)[2] * 1000); }
                        else if (units.getValue() == "ft/Nm") { offset_dist = num(split("/", point)[2] * NM2M); }
                        point = split("/", point)[0];
                    }

                    var pos_search = geo.Coord.new().set_latlon(getprop("position/latitude-deg"), getprop("position/longitude-deg"));
                    var sel_pos = selection_wpt.getValue();
                    if (dep_ap_name.getValue() != "") { sel_pos -= 1; }
                    if (sel_pos > -1 and sel_pos < size(dep_route.getChildren())) {
                        pos_search.set_latlon(dep_route.getChild("wp", sel_pos).getNode("lat").getValue(), dep_route.getChild("wp", sel_pos).getNode("lon").getValue());
                    }
                    sel_pos -= size(dep_route.getChildren());
                    if (sel_pos > -1 and sel_pos < size(route.getChildren())) {
                        pos_search.set_latlon(route.getChild("wp", sel_pos).getNode("lat").getValue(), route.getChild("wp", sel_pos).getNode("lon").getValue());
                    }
                    sel_pos -= size(route.getChildren());
                    if (sel_pos > -1 and sel_pos < size(dest_route.getChildren())) {
                        pos_search.set_latlon(dest_route.getChild("wp", sel_pos).getNode("lat").getValue(), dest_route.getChild("wp", sel_pos).getNode("lon").getValue());
                    }

                    var info = [];
                    if (airportinfo(point) != nil) { append(info, airportinfo(point)); }
                    if (navinfo(pos_search.lat(), pos_search.lon(), "fix", point) != nil) {
                        foreach (var n; navinfo(pos_search.lat(), pos_search.lon(), "fix", point)) { append(info, n); }
                    }
                    if (navinfo(pos_search.lat(), pos_search.lon(), "vor", point) != nil) {
                        foreach (var n; navinfo(pos_search.lat(), pos_search.lon(), "vor", point)) { append(info, n); }
                    }
                    if (navinfo(pos_search.lat(), pos_search.lon(), "ndb", point) != nil) {
                        foreach (var n; navinfo(pos_search.lat(), pos_search.lon(), "ndb", point)) { append(info, n); }
                    }
                    if (search_for_ils.getValue()) {
                        if (navinfo(pos_search.lat(), pos_search.lon(), "ils", point) != nil) {
                            foreach (var n; navinfo(pos_search.lat(), pos_search.lon(), "ils", point)) { append(info, n); }
                        }
                    }
                    if (navinfo(pos_search.lat(), pos_search.lon(), "dme", point) != nil) {
                        foreach (var n; navinfo(pos_search.lat(), pos_search.lon(), "dme", point)) { append(info, n); }
                    }
                    if (navinfo(pos_search.lat(), pos_search.lon(), "tacan", point) != nil) {
                        foreach (var n; navinfo(pos_search.lat(), pos_search.lon(), "tacan", point)) { append(info, n); }
                    }
                    foreach (var n; info) {
                        var wp = search.addChild("wp");
                        wp.addChild("ident").setValue(point);
                        if (offset_dist != 0) {
                            if (units.getValue() == "m/Km") { wp.getNode("ident").setValue(sprintf("%s/%.1f/%.1f", point, offset_hdg, offset_dist / 1000)); }
                            else if (units.getValue() == "ft/Nm") { wp.getNode("ident").setValue(sprintf("%s/%.1f/%.1f", point, offset_hdg, offset_dist * M2NM)); }
                        }
                        wp.addChild("name").setValue("");
                        if (n.name != nil) { wp.getNode("name").setValue(n.name); }
                        wp.addChild("alt").setDoubleValue(alt);
                        pos_search.set_latlon(n.lat, n.lon);
                        pos_search.apply_course_distance(offset_hdg, offset_dist);
                        wp.addChild("lat").setDoubleValue(pos_search.lat());
                        wp.addChild("lon").setDoubleValue(pos_search.lon());
                    }
                    if (size(split(",", point)) > 1) {
                        var wp = search.addChild("wp");
                        wp.addChild("ident").setValue(point);
                        if (offset_dist != 0) {
                            if (units.getValue() == "m/Km") { wp.getNode("ident").setValue(sprintf("%s/%.1f/%.1f", point, offset_hdg, offset_dist / 1000)); }
                            else if (units.getValue() == "ft/Nm") { wp.getNode("ident").setValue(sprintf("%s/%.1f/%.1f", point, offset_hdg, offset_dist * M2NM)); }
                        }
                        wp.addChild("name").setValue("RAW COORDINATES");
                        wp.addChild("alt").setDoubleValue(alt);
                        pos_search.set_latlon(num(split(",", point)[0]), num(split(",", point)[1]));
                        pos_search.apply_course_distance(offset_hdg, offset_dist);
                        wp.addChild("lat").setDoubleValue(pos_search.lat());
                        wp.addChild("lon").setDoubleValue(pos_search.lon());
                    }
                }

                gui.dialog_update("flight-planner");
                updateSearch();
            }

            var insert = func() {
                var wp_in = search.getChild("wp", selection_srch.getValue());

                var prev = 0;

                if (selection_wpt.getValue() == -1) {
                    var wp = route.addChild("wp");
                    wp.addChild("ident").setValue(wp_in.getNode("ident").getValue());
                    wp.addChild("name").setValue(wp_in.getNode("name").getValue());
                    wp.addChild("alt").setDoubleValue(wp_in.getNode("alt").getValue());
                    wp.addChild("lat").setDoubleValue(wp_in.getNode("lat").getValue());
                    wp.addChild("lon").setDoubleValue(wp_in.getNode("lon").getValue());
                }
                if (dep_ap_name != "") { prev = 1; }
                if (selection_wpt.getValue() >= 0 and selection_wpt.getValue() < prev + size(dep_route.getChildren()) - 1) {
                    var wp = dep_route.addChild("wp");
                    wp.addChild("ident").setValue("");
                    wp.addChild("name").setValue("");
                    wp.addChild("alt").setDoubleValue(0.0);
                    wp.addChild("lat").setDoubleValue(0.0);
                    wp.addChild("lon").setDoubleValue(0.0);
                    var i = 0;
                    for (i = size(dep_route.getChildren()) - 1; i > selection_wpt.getValue() - prev + 1; i -= 1) {
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("alt").setValue(dep_route.getNode(sprintf("wp[%d]", i - 1)).getNode("alt").getValue());
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("ident").setValue(dep_route.getNode(sprintf("wp[%d]", i - 1)).getNode("ident").getValue());
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("name").setValue(dep_route.getNode(sprintf("wp[%d]", i - 1)).getNode("name").getValue());
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("lat").setValue(dep_route.getNode(sprintf("wp[%d]", i - 1)).getNode("lat").getValue());
                        dep_route.getNode(sprintf("wp[%d]", i)).getNode("lon").setValue(dep_route.getNode(sprintf("wp[%d]", i - 1)).getNode("lon").getValue());
                    }
                    wp = dep_route.getChild("wp", i);
                    wp.getChild("ident").setValue(wp_in.getNode("ident").getValue());
                    wp.getChild("name").setValue(wp_in.getNode("name").getValue());
                    wp.getChild("alt").setDoubleValue(wp_in.getNode("alt").getValue());
                    wp.getChild("lat").setDoubleValue(wp_in.getNode("lat").getValue());
                    wp.getChild("lon").setDoubleValue(wp_in.getNode("lon").getValue());
                }
                else {
                    prev += size(dep_route.getChildren());
                    if (selection_wpt.getValue() >= prev - 1 and selection_wpt.getValue() < prev + size(route.getChildren())) {
                        var wp = route.addChild("wp");
                        wp.addChild("ident").setValue("");
                        wp.addChild("name").setValue("");
                        wp.addChild("alt").setDoubleValue(0.0);
                        wp.addChild("lat").setDoubleValue(0.0);
                        wp.addChild("lon").setDoubleValue(0.0);
                        var i = 0;
                        for (i = size(route.getChildren()) - 1; i > selection_wpt.getValue() - prev + 1; i -= 1) {
                            route.getNode(sprintf("wp[%d]", i)).getNode("alt").setValue(route.getNode(sprintf("wp[%d]", i - 1)).getNode("alt").getValue());
                            route.getNode(sprintf("wp[%d]", i)).getNode("ident").setValue(route.getNode(sprintf("wp[%d]", i - 1)).getNode("ident").getValue());
                            route.getNode(sprintf("wp[%d]", i)).getNode("name").setValue(route.getNode(sprintf("wp[%d]", i - 1)).getNode("name").getValue());
                            route.getNode(sprintf("wp[%d]", i)).getNode("lat").setValue(route.getNode(sprintf("wp[%d]", i - 1)).getNode("lat").getValue());
                            route.getNode(sprintf("wp[%d]", i)).getNode("lon").setValue(route.getNode(sprintf("wp[%d]", i - 1)).getNode("lon").getValue());
                        }
                        wp = route.getChild("wp", i);
                        wp.getChild("ident").setValue(wp_in.getNode("ident").getValue());
                        wp.getChild("name").setValue(wp_in.getNode("name").getValue());
                        wp.getChild("alt").setDoubleValue(wp_in.getNode("alt").getValue());
                        wp.getChild("lat").setDoubleValue(wp_in.getNode("lat").getValue());
                        wp.getChild("lon").setDoubleValue(wp_in.getNode("lon").getValue());
                    }
                    else {
                        prev += size(route.getChildren());
                        if (selection_wpt.getValue() >= prev and selection_wpt.getValue() < prev + size(dest_route.getChildren())) {
                            var wp = dest_route.addChild("wp");
                            wp.addChild("ident").setValue("");
                            wp.addChild("name").setValue("");
                            wp.addChild("alt").setDoubleValue(0.0);
                            wp.addChild("lat").setDoubleValue(0.0);
                            wp.addChild("lon").setDoubleValue(0.0);
                            var i = 0;
                            for (i = size(dest_route.getChildren()) - 1; i > selection_wpt.getValue() - prev + 1; i -= 1) {
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("alt").setValue(dest_route.getNode(sprintf("wp[%d]", i - 1)).getNode("alt").getValue());
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("ident").setValue(dest_route.getNode(sprintf("wp[%d]", i - 1)).getNode("ident").getValue());
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("name").setValue(dest_route.getNode(sprintf("wp[%d]", i - 1)).getNode("name").getValue());
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("lat").setValue(dest_route.getNode(sprintf("wp[%d]", i - 1)).getNode("lat").getValue());
                                dest_route.getNode(sprintf("wp[%d]", i)).getNode("lon").setValue(dest_route.getNode(sprintf("wp[%d]", i - 1)).getNode("lon").getValue());
                            }
                            wp = dest_route.getChild("wp", i);
                            wp.getChild("ident").setValue(wp_in.getNode("ident").getValue());
                            wp.getChild("name").setValue(wp_in.getNode("name").getValue());
                            wp.getChild("alt").setDoubleValue(wp_in.getNode("alt").getValue());
                            wp.getChild("lat").setDoubleValue(wp_in.getNode("lat").getValue());
                            wp.getChild("lon").setDoubleValue(wp_in.getNode("lon").getValue());
                        }
                    }
                }
            
                selection_wpt.setIntValue(-1);
                selection_srch.setIntValue(-1);
                input.setValue("");
                search.removeAllChildren();
                gui.dialog_update("flight-planner");
                updateRoute();
                updateSearch();
            }

            var LoadFlightplanXml = func(filename) {
                var temp_file = io.open(dir ~ "/temp_fp.xml", "w");
                io.write(temp_file, io.readfile(filename.getValue()));
                io.close(temp_file);
                LoadTempFlightplan();
            }

            var LoadTempFlightplan = func() {
                temp_fp.removeAllChildren();
                fgcommand("loadxml", {
                    'filename'   : dir ~ "/temp_fp.xml",
                    'targetnode' : '/sim/gui/dialogs/flight-planner/temp_fp'
                });

                cruise_altitude.setDoubleValue(0.0);
                if (temp_fp.getNode("cruise") != nil) {
                    if (temp_fp.getNode("cruise").getNode("altitude-ft") != nil) {
                        if (units.getValue() == "m/Km") { cruise_altitude.setDoubleValue(temp_fp.getNode("cruise").getNode("altitude-ft").getValue() * FT2M); }
                        else if (units.getValue() == "ft/Nm") { cruise_altitude.setDoubleValue(temp_fp.getNode("cruise").getNode("altitude-ft").getValue()); }
                    }
                }

                dep_ap.setValue("");
                if (temp_fp.getNode("departure") != nil) {
                    dep_ap.setValue(temp_fp.getNode("departure").getNode("airport").getValue());
                }
                updateDeparture();
                if (temp_fp.getNode("departure") != nil) {
                    if (temp_fp.getNode("departure").getNode("runway") != nil) {
                        dep_runway.setValue(temp_fp.getNode("departure").getNode("runway").getValue());
                    }
                }

                dest_ap.setValue("");
                if (temp_fp.getNode("destination") != nil) {
                    dest_ap.setValue(temp_fp.getNode("destination").getNode("airport").getValue());
                }
                updateArrival();
                if (temp_fp.getNode("destination") != nil) {
                    if (temp_fp.getNode("destination").getNode("runway") != nil) {
                        dest_runway.setValue(temp_fp.getNode("destination").getNode("runway").getValue());
                    }
                }

                clear();
                if (temp_fp.getNode("route") != nil) {
                    var stage = 0;
                    foreach (var n; temp_fp.getNode("route").getChildren()) {
                        if ((n.getNode("type").getValue() == "basic" or n.getNode("type").getValue() == "navaid") and (stage == 0 or stage == 1) and n.getNode("departure") != nil) {
                            stage = 1;
                            var node = dep_route.addChild("wp");
                            node.getNode("alt", 1).setDoubleValue(-9999);
                            if (n.getNode("altitude-ft") != nil) {
                                node.getNode("alt").setDoubleValue(n.getNode("altitude-ft").getValue() * FT2M);
                            }
                            node.getNode("ident", 1).setValue(n.getNode("ident").getValue());
                            node.getNode("name", 1).setValue("");
                            node.getNode("lat", 1).setDoubleValue(n.getNode("lat").getValue());
                            node.getNode("lon", 1).setDoubleValue(n.getNode("lon").getValue());

                            var id = split("/", node.getNode("ident").getValue())[0];
                            var info = navinfo(node.getNode("lat").getValue(), node.getNode("lon").getValue(), "any", id);
                            if (size(info) > 0) {
                                info = info[0];
                                if (info.name != nil) { node.getNode("name").setValue(info.name); }
                            }
                            if (airportinfo(id) != nil) { node.getNode("name").setValue(airportinfo(id).name); }
                        }
                        if ((n.getNode("type").getValue() == "basic" or n.getNode("type").getValue() == "navaid") and (stage == 0 or stage == 1 or stage == 2) and n.getNode("departure") == nil and n.getNode("approach") == nil) {
                            stage = 2;
                            var node = route.addChild("wp");
                            node.getNode("alt", 1).setDoubleValue(-9999);
                            if (n.getNode("altitude-ft") != nil) {
                                if (units.getValue() == "m/Km") { node.getNode("alt").setDoubleValue(n.getNode("altitude-ft").getValue() * FT2M); }
                                else if (units.getValue() == "ft/Nm") { node.getNode("alt").setDoubleValue(n.getNode("altitude-ft").getValue()); }
                            }
                            node.getNode("ident", 1).setValue(n.getNode("ident").getValue());
                            node.getNode("name", 1).setValue("");
                            node.getNode("lat", 1).setDoubleValue(n.getNode("lat").getValue());
                            node.getNode("lon", 1).setDoubleValue(n.getNode("lon").getValue());

                            var id = split("/", node.getNode("ident").getValue())[0];
                            var info = navinfo(node.getNode("lat").getValue(), node.getNode("lon").getValue(), "any", id);
                            if (size(info) > 0) {
                                info = info[0];
                                if (info.name != nil) { node.getNode("name").setValue(info.name); }
                            }
                            if (airportinfo(id) != nil) { node.getNode("name").setValue(airportinfo(id).name); }
                        }
                        if ((n.getNode("type").getValue() == "basic" or n.getNode("type").getValue() == "navaid") and (stage == 2 or stage == 3) and n.getNode("approach") != nil) {
                            stage = 3;
                            var node = dest_route.addChild("wp");
                            node.getNode("alt", 1).setDoubleValue(-9999);
                            if (n.getNode("altitude-ft") != nil) {
                                node.getNode("alt").setDoubleValue(n.getNode("altitude-ft").getValue() * FT2M);
                            }
                            node.getNode("ident", 1).setValue(n.getNode("ident").getValue());
                            node.getNode("name", 1).setValue("");
                            node.getNode("lat", 1).setDoubleValue(n.getNode("lat").getValue());
                            node.getNode("lon", 1).setDoubleValue(n.getNode("lon").getValue());

                            var id = split("/", node.getNode("ident").getValue())[0];
                            var info = navinfo(node.getNode("lat").getValue(), node.getNode("lon").getValue(), "any", id);
                            if (size(info) > 0) {
                                info = info[0];
                                if (info.name != nil) { node.getNode("name").setValue(info.name); }
                            }
                            if (airportinfo(id) != nil) { node.getNode("name").setValue(airportinfo(id).name); }
                        }
                    }
                }

                gui.dialog_update("flight-planner");
                updateRoute();
            }

            var load_route = func() {
                var selector = gui.FileSelector.new(
                    callback: LoadFlightplanXml,
                    dir: dir,
                    dotfiles: 1,
                    title: "Load Flight Plan",
                    button: "Load"
                );
                selector.open();
                selector.del();
            }

            var SaveFlightplanXml = func(filename_raw) {
                var filename = "";
                if (isstr(filename_raw)) { filename = filename_raw; }
                else { filename = filename_raw.getValue(); }

                temp_fp.removeAllChildren();
                temp_fp.getNode("version", 1).setIntValue(2);
                var temp_route = temp_fp.getNode("route", 1);
                if (units.getValue() == "m/Km") { temp_fp.getNode("cruise", 1).getNode("altitude-ft", 1).setIntValue(int(cruise_altitude.getValue() * M2FT)); }
                else if (units.getValue() == "ft/Nm") { temp_fp.getNode("cruise", 1).getNode("altitude-ft", 1).setIntValue(int(cruise_altitude.getValue())); }

                if (dep_ap_name.getValue() != nil) {
                    var node = temp_fp.getNode("departure", 1);
                    node.getNode("airport", 1).setValue(dep_ap.getValue());
                    node.getNode("runway", 1).setValue(dep_runway.getValue());

                    node = temp_route.addChild("wp");
                    node.getNode("type", 1).setValue("runway");
                    node.getNode("departure", 1).setBoolValue(1);
                    node.getNode("ident", 1).setValue(dep_runway.getValue());
                    node.getNode("icao", 1).setValue(dep_ap.getValue());
                }

                foreach (var n; dep_route.getChildren()) {
                    node = temp_route.addChild("wp");
                    node.getNode("type", 1).setValue("basic");
                    if (filename_raw != dir ~ "/temp_fp.xml") { node.getNode("departure", 1).setBoolValue(1); }
                    if (n.getNode("alt").getValue() > -2000) {
                        node.getNode("alt-restrict", 1).setValue("at");
                        node.getNode("altitude-ft", 1).setIntValue(n.getNode("alt").getValue() * M2FT);
                    }
                    node.getNode("ident", 1).setValue(n.getNode("ident").getValue());
                    node.getNode("lat", 1).setDoubleValue(n.getNode("lat").getValue());
                    node.getNode("lon", 1).setDoubleValue(n.getNode("lon").getValue());
                }

                foreach (var n; route.getChildren()) {
                    node = temp_route.addChild("wp");
                    node.getNode("type", 1).setValue("navaid");
                    if (n.getNode("alt").getValue() > -2000) {
                        node.getNode("alt-restrict", 1).setValue("at");
                        node.getNode("altitude-ft", 1).setIntValue(n.getNode("alt").getValue());
                        if (units.getValue() == "m/Km") { node.getNode("altitude-ft", 1).setIntValue(n.getNode("alt").getValue() * M2FT); }
                        else if (units.getValue() == "ft/Nm") { node.getNode("altitude-ft", 1).setIntValue(n.getNode("alt").getValue()); }
                    }
                    node.getNode("ident", 1).setValue(n.getNode("ident").getValue());
                    node.getNode("lat", 1).setDoubleValue(n.getNode("lat").getValue());
                    node.getNode("lon", 1).setDoubleValue(n.getNode("lon").getValue());
                }

                foreach (var n; dest_route.getChildren()) {
                    node = temp_route.addChild("wp");
                    node.getNode("type", 1).setValue("basic");
                    if (filename_raw != dir ~ "/temp_fp.xml") { node.getNode("approach", 1).setBoolValue(1); }
                    if (n.getNode("alt").getValue() > -2000) {
                        node.getNode("alt-restrict", 1).setValue("at");
                        node.getNode("altitude-ft", 1).setIntValue(n.getNode("alt").getValue() * M2FT);
                    }
                    node.getNode("ident", 1).setValue(n.getNode("ident").getValue());
                    node.getNode("lat", 1).setDoubleValue(n.getNode("lat").getValue());
                    node.getNode("lon", 1).setDoubleValue(n.getNode("lon").getValue());
                }

                if (dest_ap_name.getValue() != nil) {
                    var node = temp_fp.getNode("destination", 1);
                    node.getNode("airport", 1).setValue(dest_ap.getValue());
                    node.getNode("runway", 1).setValue(dest_runway.getValue());

                    node = temp_route.addChild("wp");
                    node.getNode("type", 1).setValue("runway");
                    node.getNode("approach", 1).setBoolValue(1);
                    node.getNode("ident", 1).setValue(dest_runway.getValue());
                    node.getNode("icao", 1).setValue(dest_ap.getValue());
                }

                io.write_properties(dir ~ "/temp_fp", temp_fp);
                var temp_filec_contents = io.readfile(dir ~ "/temp_fp.xml");
                var temp_file = io.open(filename, "w");
                io.write(temp_file, temp_filec_contents);
                io.close(temp_file);

                gui.dialog_update("flight-planner");
            }

            var save_route = func() {
                var selector = gui.FileSelector.new(
                    callback: SaveFlightplanXml,
                    dir: dir,
                    dotfiles: 1,
                    title: "Save Flight Plan",
                    button: "Save"
                );
                selector.open();
                selector.del();
            }

            var flip = func() {
                temp_fp.removeAllChildren();
                temp_fp.getNode("version", 1).setIntValue(2);
                var temp_route = temp_fp.getNode("route", 1);

                if (dep_ap_name.getValue() != nil) {
                    var node = temp_fp.getNode("departure", 1);
                    node.getNode("airport", 1).setValue(dep_ap.getValue());
                    node.getNode("runway", 1).setValue(dep_runway.getValue());
                }

                foreach (var n; route.getChildren()) {
                    node = temp_route.addChild("wp");
                    node.getNode("type", 1).setValue("navaid");
                    if (n.getNode("alt").getValue() > -2000) {
                        node.getNode("alt-restrict", 1).setValue("at");
                        node.getNode("altitude-ft", 1).setIntValue(n.getNode("alt").getValue());
                        if (units.getValue() == "m/Km") { node.getNode("altitude-ft", 1).setIntValue(n.getNode("alt").getValue() * M2FT); }
                        else if (units.getValue() == "ft/Nm") { node.getNode("altitude-ft", 1).setIntValue(n.getNode("alt").getValue()); }
                    }
                    node.getNode("ident", 1).setValue(n.getNode("ident").getValue());
                    node.getNode("lat", 1).setDoubleValue(n.getNode("lat").getValue());
                    node.getNode("lon", 1).setDoubleValue(n.getNode("lon").getValue());
                }

                if (dest_ap_name.getValue() != nil) {
                    var node = temp_fp.getNode("destination", 1);
                    node.getNode("airport", 1).setValue(dest_ap.getValue());
                    node.getNode("runway", 1).setValue(dest_runway.getValue());
                }


                dep_ap.setValue("");
                if (temp_fp.getNode("destination") != nil) {
                    dep_ap.setValue(temp_fp.getNode("destination").getNode("airport").getValue());
                }
                updateDeparture();
                if (temp_fp.getNode("destination") != nil) {
                    if (temp_fp.getNode("destination").getNode("runway") != nil) {
                        dep_runway.setValue(temp_fp.getNode("destination").getNode("runway").getValue());
                    }
                }

                dest_ap.setValue("");
                if (temp_fp.getNode("departure") != nil) {
                    dest_ap.setValue(temp_fp.getNode("departure").getNode("airport").getValue());
                }
                updateArrival();
                if (temp_fp.getNode("departure") != nil) {
                    if (temp_fp.getNode("departure").getNode("runway") != nil) {
                        dest_runway.setValue(temp_fp.getNode("departure").getNode("runway").getValue());
                    }
                }

                clear();
                if (temp_fp.getNode("route") != nil) {
                    for (var i = size(temp_fp.getNode("route").getChildren()) - 1; i >= 0; i-=1) {
                        var n = temp_fp.getNode("route").getChild("wp", i, 1);
                        var node = route.addChild("wp");
                        node.getNode("alt", 1).setDoubleValue(-9999);
                        if (n.getNode("altitude-ft") != nil) {
                            if (units.getValue() == "m/Km") { node.getNode("alt").setDoubleValue(n.getNode("altitude-ft").getValue() * FT2M); }
                            else if (units.getValue() == "ft/Nm") { node.getNode("alt").setDoubleValue(n.getNode("altitude-ft").getValue()); }
                        }
                        node.getNode("ident", 1).setValue(n.getNode("ident").getValue());
                        node.getNode("name", 1).setValue("");
                        node.getNode("lat", 1).setDoubleValue(n.getNode("lat").getValue());
                        node.getNode("lon", 1).setDoubleValue(n.getNode("lon").getValue());

                        var id = split("/", node.getNode("ident").getValue())[0];
                        var info = navinfo(node.getNode("lat").getValue(), node.getNode("lon").getValue(), "any", id);
                        if (size(info) > 0) {
                            info = info[0];
                            if (info.name != nil) { node.getNode("name").setValue(info.name); }
                        }
                        if (airportinfo(id) != nil) { node.getNode("name").setValue(airportinfo(id).name); }
                    }
                }

                gui.dialog_update("t144-flight-planner");
                updateRoute();
            }



            if (tabs_restored.getValue() == nil) {
                var temp_file = io.open(dir ~ "/tabs_fp.xml", "a");
                io.close(temp_file);
                fgcommand("loadxml", {
                    'filename'   : dir ~ "/tabs_fp.xml",
                    'targetnode' : '/sim/gui/dialogs/flight-planner/tabs'
                });

                var next = 1;
                if (tabs[next].getNode("cruise_altitude", 1).getValue() != nil) { cruise_altitude.setDoubleValue(tabs[next].getNode("cruise_altitude").getValue()); }
                if (tabs[next].getNode("departure", 1).getNode("airport", 1).getValue() != nil) { dep_ap.setValue(tabs[next].getNode("departure").getNode("airport").getValue()); }
                updateDeparture();
                if (tabs[next].getNode("departure", 1).getNode("runway", 1).getValue() != nil) { dep_runway.setValue(tabs[next].getNode("departure").getNode("runway").getValue()); }
                if (tabs[next].getNode("destination", 1).getNode("airport", 1).getValue() != nil) { dest_ap.setValue(tabs[next].getNode("destination").getNode("airport").getValue()); }
                updateArrival();
                if (tabs[next].getNode("destination", 1).getNode("runway", 1).getValue() != nil) { dest_runway.setValue(tabs[next].getNode("destination").getNode("runway").getValue()); }
                dep_route.removeAllChildren();
                foreach(var n; tabs[next].getNode("departure", 1).getNode("route", 1).getChildren()) {
                    var wp = dep_route.addChild("wp");
                    wp.addChild("ident").setValue(n.getNode("ident").getValue());
                    wp.addChild("name").setValue(n.getNode("name").getValue());
                    wp.addChild("alt").setValue(n.getNode("alt").getValue());
                    wp.addChild("lat").setValue(n.getNode("lat").getValue());
                    wp.addChild("lon").setValue(n.getNode("lon").getValue());
                }
                route.removeAllChildren();
                foreach(var n; tabs[next].getNode("route", 1).getChildren()) {
                    var wp = route.addChild("wp");
                    wp.addChild("ident").setValue(n.getNode("ident").getValue());
                    wp.addChild("name").setValue(n.getNode("name").getValue());
                    wp.addChild("alt").setValue(n.getNode("alt").getValue());
                    wp.addChild("lat").setValue(n.getNode("lat").getValue());
                    wp.addChild("lon").setValue(n.getNode("lon").getValue());
                }
                dest_route.removeAllChildren();
                foreach(var n; tabs[next].getNode("destination", 1).getNode("route", 1).getChildren()) {
                    var wp = dest_route.addChild("wp");
                    wp.addChild("ident").setValue(n.getNode("ident").getValue());
                    wp.addChild("name").setValue(n.getNode("name").getValue());
                    wp.addChild("alt").setValue(n.getNode("alt").getValue());
                    wp.addChild("lat").setValue(n.getNode("lat").getValue());
                    wp.addChild("lon").setValue(n.getNode("lon").getValue());
                }
            }
            for (var i = 1; i < 4; i += 1) {
                tabs[i].getNode("selected", 1).setIntValue(0);
                tabs[tab.getValue()].getNode("selected", 1).setIntValue(1);
                tabs[i].getNode("departure", 1);
                tabs[i].getNode("departure").getNode("airport", 1);
                if (tabs[i].getNode("departure").getNode("airport").getValue() == nil) { tabs[i].getNode("departure").getNode("airport").setValue(""); }
                tabs[i].getNode("departure").getNode("name", 1);
                if (tabs[i].getNode("departure").getNode("name").getValue() == nil) { tabs[i].getNode("departure").getNode("name").setValue(""); }
                tabs[i].getNode("departure").getNode("runway", 1);
                if (tabs[i].getNode("departure").getNode("runway").getValue() == nil) { tabs[i].getNode("departure").getNode("runway").setValue(""); }
                tabs[i].getNode("departure").getNode("route", 1);
                tabs[i].getNode("destination", 1);
                tabs[i].getNode("destination").getNode("airport", 1);
                if (tabs[i].getNode("destination").getNode("airport").getValue() == nil) { tabs[i].getNode("destination").getNode("airport").setValue(""); }
                tabs[i].getNode("destination").getNode("name", 1);
                if (tabs[i].getNode("destination").getNode("name").getValue() == nil) { tabs[i].getNode("destination").getNode("name").setValue(""); }
                tabs[i].getNode("destination").getNode("runway", 1);
                if (tabs[i].getNode("destination").getNode("runway").getValue() == nil) { tabs[i].getNode("destination").getNode("runway").setValue(""); }
                tabs[i].getNode("destination").getNode("route", 1);
                tabs[i].getNode("cruise_altitude", 1);
                if (tabs[i].getNode("cruise_altitude").getValue() == nil) { tabs[i].getNode("cruise_altitude").setDoubleValue(0.0); }
                tabs[i].getNode("route", 1);
            }
            if (tabs_restored.getValue() == nil) {
                gui.dialog_update("t144-flight-planner");
                updateRoute();
                tabs_restored.setBoolValue(1);
            }
        ]]></open>

        <close><![CDATA[
            tabs[tab.getValue()].getNode("cruise_altitude").setDoubleValue(cruise_altitude.getValue());
            tabs[tab.getValue()].getNode("departure").getNode("airport").setValue(dep_ap.getValue());
            tabs[tab.getValue()].getNode("departure").getNode("runway").setValue(dep_runway.getValue());
            tabs[tab.getValue()].getNode("destination").getNode("airport").setValue(dest_ap.getValue());
            tabs[tab.getValue()].getNode("destination").getNode("runway").setValue(dest_runway.getValue());
            tabs[tab.getValue()].getNode("departure").getNode("route").removeAllChildren();
            foreach(var n; dep_route.getChildren()) {
                var wp = tabs[tab.getValue()].getNode("departure").getNode("route").addChild("wp");
                wp.addChild("ident").setValue(n.getNode("ident").getValue());
                wp.addChild("name").setValue(n.getNode("name").getValue());
                wp.addChild("alt").setValue(n.getNode("alt").getValue());
                wp.addChild("lat").setValue(n.getNode("lat").getValue());
                wp.addChild("lon").setValue(n.getNode("lon").getValue());
            }
            tabs[tab.getValue()].getNode("route").removeAllChildren();
            foreach(var n; route.getChildren()) {
                var wp = tabs[tab.getValue()].getNode("route").addChild("wp");
                wp.addChild("ident").setValue(n.getNode("ident").getValue());
                wp.addChild("name").setValue(n.getNode("name").getValue());
                wp.addChild("alt").setValue(n.getNode("alt").getValue());
                wp.addChild("lat").setValue(n.getNode("lat").getValue());
                wp.addChild("lon").setValue(n.getNode("lon").getValue());
            }
            tabs[tab.getValue()].getNode("destination").getNode("route").removeAllChildren();
            foreach(var n; dest_route.getChildren()) {
                var wp = tabs[tab.getValue()].getNode("destination").getNode("route").addChild("wp");
                wp.addChild("ident").setValue(n.getNode("ident").getValue());
                wp.addChild("name").setValue(n.getNode("name").getValue());
                wp.addChild("alt").setValue(n.getNode("alt").getValue());
                wp.addChild("lat").setValue(n.getNode("lat").getValue());
                wp.addChild("lon").setValue(n.getNode("lon").getValue());
            }

            io.write_properties(dir ~ "/tabs_fp", props.globals.getNode("/sim/gui/dialogs/flight-planner", 1).getNode("tabs", 1));
        ]]></close>
    </nasal>

    <group>
        <layout>hbox</layout>
        <empty><stretch>1</stretch></empty>

        <text>
            <label>Flight Planner</label>
        </text>

        <empty><stretch>1</stretch></empty>

        <button>
            <pref-width>16</pref-width>
            <pref-height>16</pref-height>
            <legend></legend>
            <default>1</default>
            <keynum>27</keynum>
            <border>2</border>

            <binding>
                <command>dialog-close</command>
            </binding>
        </button>
    </group>
    <hrule/>
    
    <group>
        <layout>hbox</layout>
        <halign>fill</halign>
        <default-padding>4</default-padding>

        <button>
            <halign>fill</halign>
            <stretch>true</stretch>
            <pref-height>20</pref-height>
            <live>1</live>
            <legend>1</legend>
            <property>/sim/gui/dialogs/flight-planner/tabs/tab[1]/selected</property>
            <binding>
                <command>nasal</command>
                <script>tab_load(1);</script>
            </binding>
        </button>

        <button>
            <halign>fill</halign>
            <stretch>true</stretch>
            <pref-height>20</pref-height>
            <live>1</live>
            <legend>2</legend>
            <property>/sim/gui/dialogs/flight-planner/tabs/tab[2]/selected</property>
            <binding>
                <command>nasal</command>
                <script>tab_load(2);</script>
            </binding>
        </button>

        <button>
            <halign>fill</halign>
            <stretch>true</stretch>
            <pref-height>20</pref-height>
            <live>1</live>
            <legend>3</legend>
            <property>/sim/gui/dialogs/flight-planner/tabs/tab[3]/selected</property>
            <binding>
                <command>nasal</command>
                <script>tab_load(3);</script>
            </binding>
        </button>
    </group>
    <hrule/>

    <!-- departure / arrival airport information -->

    <group>
        <layout>table</layout>
        <text>
            <row>0</row>
            <col>0</col>
            <halign>right</halign>
            <label> Departure:</label>
        </text>
        <input>
            <row>0</row>
            <col>1</col>
            <halign>left</halign>
            <name>departure-airport</name>
            <pref-width>70</pref-width>
            <property>/sim/gui/dialogs/flight-planner/departure/airport</property>
            <live>true</live>
            <binding>
                <command>dialog-apply</command>
                <object-name>departure-airport</object-name>
            </binding>
            <binding>
                <command>nasal</command>
                <script>updateDeparture();</script>
            </binding>
        </input>

        <text>
            <row>0</row>
            <col>2</col>
            <format>%s</format>
            <property>/sim/gui/dialogs/flight-planner/departure/name</property>
            <live>true</live>
            <stretch>true</stretch>
            <halign>fill</halign>
        </text>

        <text>
            <row>0</row>
            <col>3</col>
            <halign>right</halign>
            <label>Rwy:</label>
        </text>
        <combo>
            <row>0</row>
            <col>4</col>
            <halign>left</halign>
            <name>departure-runway</name>
            <live>true</live>
            <property>/sim/gui/dialogs/flight-planner/departure/runway</property>
            <editable>false</editable>
            <properties>/sim/gui/dialogs/flight-planner/departure/runways</properties>

            <binding>
                <command>dialog-apply</command>
                <object-name>departure-runway</object-name>
            </binding>
            <!--<binding>
                <command>nasal</command>
                <script>dep_route.removeAllChildren();</script>
            </binding>-->
            <binding>
                <command>nasal</command>
                <script>updateRoute();</script>
            </binding>
        </combo>

        <text>
            <row>0</row>
            <col>5</col>
            <halign>right</halign>
            <label>Departure:</label>
        </text>
        <button>
            <row>0</row>
            <col>6</col>
            <legend>Generate</legend>
            <equal>true</equal>
            <enable>
                <and>
                    <not-equals>
                        <property>/sim/gui/dialogs/flight-planner/departure/name</property>
                        <value></value>
                    </not-equals>
                    <not-equals>
                        <property>/sim/gui/dialogs/flight-planner/destination/name</property>
                        <value></value>
                    </not-equals>
                </and>
            </enable>
            <binding>
                <command>nasal</command>
                <script>generate_sid();</script>
            </binding>
        </button>

        <text>
            <row>1</row>
            <col>0</col>
            <halign>right</halign>
            <label>Arrival:</label>
        </text>
        <input>
            <row>1</row>
            <col>1</col>
            <halign>left</halign>
            <pref-width>70</pref-width>
            <name>destination-airport</name>
            <property>/sim/gui/dialogs/flight-planner/destination/airport</property>
            <live>true</live>
            <binding>
                <command>dialog-apply</command>
                <object-name>destination-airport</object-name>
            </binding>
            <binding>
                <command>nasal</command>
                <script>updateArrival();</script>
            </binding>
        </input>
        <text>
            <row>1</row>
            <col>2</col>
            <stretch>true</stretch>
            <pref-width>200</pref-width>
            <format>%s</format>
            <property>/sim/gui/dialogs/flight-planner/destination/name</property>
            <live>true</live>
            <halign>fill</halign>
        </text>

        <text>
            <row>1</row>
            <col>3</col>
            <halign>right</halign>
            <label>Rwy:</label>
        </text>
        <combo>
            <row>1</row>
            <col>4</col>
            <halign>left</halign>
            <name>destination-runway</name>
            <live>true</live>
            <property>/sim/gui/dialogs/flight-planner/destination/runway</property>
            <editable>false</editable>
            <properties>/sim/gui/dialogs/flight-planner/destination/runways</properties>

            <binding>
                <command>dialog-apply</command>
                <object-name>destination-runway</object-name>
            </binding>
            <!--<binding>
                <command>nasal</command>
                <script>dest_route.removeAllChildren();</script>
            </binding>-->
            <binding>
                <command>nasal</command>
                <script>updateRoute();</script>
            </binding>
        </combo>


        <text>
            <row>1</row>
            <col>5</col>
            <halign>right</halign>
            <label>Approach:</label>
        </text>
        <button>
            <row>1</row>
            <col>6</col>
            <legend>Generate</legend>
            <equal>true</equal>
            <enable>
                <and>
                    <not-equals>
                        <property>/sim/gui/dialogs/flight-planner/departure/name</property>
                        <value></value>
                    </not-equals>
                    <not-equals>
                        <property>/sim/gui/dialogs/flight-planner/destination/name</property>
                        <value></value>
                    </not-equals>
                </and>
            </enable>
            <binding>
                <command>nasal</command>
                <script>generate_approach();</script>
            </binding>
        </button>
    </group>


    <group>
        <layout>hbox</layout>
        <!-- gap -->
        <text>
          <label> </label>
        </text>

        <text>
            <label>Cruise Altitude (m/ft):</label>
            <halign>right</halign>
        </text>
        <input>
            <name>cruise-alt</name>
            <live>true</live>
            <halign>left</halign>
            <stretch>true</stretch>
            <pref-width>100</pref-width>
            <property>/sim/gui/dialogs/flight-planner/cruise_altitude</property>
            <binding>
                <command>dialog-apply</command>
                <object-name>cruise-alt</object-name>
            </binding>
        </input>

        <empty><stretch>1</stretch></empty>

        <text>
            <label>Total dist:</label>
            <halign>right</halign>
        </text>
        <text>
            <!--<stretch>true</stretch>-->
            <pref-width>100</pref-width>
            <format>%s</format>
            <property>/sim/gui/dialogs/flight-planner/dist</property>
            <live>true</live>
            <halign>fill</halign>
        </text>

        <empty><stretch>1</stretch></empty>

        <text>
            <halign>right</halign>
            <label>DEP/ARR:</label>
        </text>
        <combo>
            <halign>left</halign>
            <name>baro</name>
            <live>true</live>
            <property>/sim/gui/dialogs/flight-planner/baro</property>
            <editable>false</editable>
            <properties>/sim/gui/dialogs/flight-planner/baros</properties>

            <binding>
                <command>dialog-apply</command>
                <object-name>baro</object-name>
            </binding>
        </combo>

        <!-- gap -->
        <text>
          <label> </label>
        </text>
    </group>


    <group>
        <layout>hbox</layout>
        <text>
          <label> </label>
        </text>

        <text>
            <label>Flip DEP/ARR (also reverts a route):</label>
            <halign>right</halign>
        </text>
        <button>
            <legend>/\   \/</legend>
            <equal>true</equal>
            <binding>
                <command>nasal</command>
                <script>flip();</script>
            </binding>
        </button>

        <empty><stretch>1</stretch></empty>

        <button>
            <legend>Get From Route Manager</legend>
            <default>true</default>
            <binding>
                <command>nasal</command>
                <script>pullFromRm();</script>
            </binding>
        </button>
    </group>

    <hrule/>

    <group>
        <layout>hbox</layout>
        <default-padding>2</default-padding>
        <stretch>true</stretch>
        <halign>fill</halign>
        <valign>fill</valign>

        <!-- gap -->
        <text>
          <label> </label>
        </text>

        <list>
            <name>list_wpt</name>
            <halign>fill</halign>
            <valign>fill</valign>
            <stretch>true</stretch>
            <pref-height>312</pref-height>
            <property>/sim/gui/dialogs/flight-planner/selection_wpt</property>
            <binding>
                <command>dialog-apply</command>
                <object-name>list_wpt</object-name>
            </binding>
        </list>

        <!-- gap -->
        <text>
          <label> </label>
        </text>

    </group>

    <group>
        <layout>hbox</layout>
        <halign>fill</halign>
        <default-padding>8</default-padding>

        <button>
            <legend>Clear List</legend>
            <equal>true</equal>
            <binding>
                <command>nasal</command>
                <script>clear()</script>
            </binding>
        </button>

        <button>
            <legend>Remove</legend>
            <equal>true</equal>
            <enable>
                <greater-than>
                <property>/sim/gui/dialogs/flight-planner/selection_wpt</property>
                <value>-1</value>
                </greater-than>
            </enable>
            <binding>
                <command>nasal</command>
                <script>remove()</script>
            </binding>
        </button>

        <empty><stretch>1</stretch></empty>

        <text>
            <halign>right</halign>
            <label>Units:</label>
        </text>
        <combo>
            <halign>left</halign>
            <name>units</name>
            <live>true</live>
            <property>/sim/gui/dialogs/flight-planner/units</property>
            <editable>false</editable>
            <properties>/sim/gui/dialogs/flight-planner/units_set</properties>

            <binding>
                <command>dialog-apply</command>
                <object-name>units</object-name>
            </binding>
            <binding>
                <command>nasal</command>
                <script>updateRoute();</script>
            </binding>
        </combo>

        <empty><stretch>1</stretch></empty>
    </group>

    <hrule/>

    <group>
        <layout>hbox</layout>
        <default-padding>4</default-padding>

        <text>
            <label>  Point:</label>
<!--
            <pref-width>60</pref-width>
-->
        </text>

        <input>
            <name>input</name>
            <live>true</live>
            <halign>fill</halign>
            <stretch>true</stretch>
            <pref-width>220</pref-width>
            <property>/sim/gui/dialogs/flight-planner/input</property>
            <binding>
                <command>dialog-apply</command>
                <object-name>input</object-name>
            </binding>
            <binding>
                <command>nasal</command>
                <script>input.setValue(string.uc(input.getValue()));</script>
            </binding>
            <binding>
                <command>dialog-update</command>
            </binding>
        </input>

        <button>
            <legend>Search</legend>
            <equal>true</equal>
            <binding>
                <command>dialog-update</command>
            </binding>
            <binding>
                <command>nasal</command>
                <script>do_search();</script>
            </binding>
        </button>

        <!-- gap -->
        <text>
          <label></label>
        </text>
    </group>

    <text>
        <padding>1</padding>
        <label>Format: [airport|fix|nav|lat,lon] with optional @alt -- e.g. "KSFO@900"</label>
    </text>
      <text>
        <padding>1</padding>
        <label>Lat,lon can be entered signed, e.g. "-2.5,51.3"</label>
    </text>
    <text>
        <padding>1</padding>
        <label>   Any location can be be offset by a radial and distance in given units, e.g. "DCS/45/10@2000" or "18.5,-33.9/290/4.5"   </label>
    </text>

    <group>
        <layout>hbox</layout>
        <default-padding>2</default-padding>
        <stretch>true</stretch>
        <halign>fill</halign>
        <valign>fill</valign>

        <!-- gap -->
        <text>
          <label> </label>
        </text>

        <list>
            <name>list_srch</name>
            <halign>fill</halign>
            <valign>fill</valign>
            <stretch>true</stretch>
            <pref-height>112</pref-height>
            <property>/sim/gui/dialogs/flight-planner/selection_srch</property>
            <binding>
                <command>dialog-apply</command>
                <object-name>list_srch</object-name>
            </binding>
        </list>

        <!-- gap -->
        <text>
          <label> </label>
        </text>

    </group>

    <group>
        <layout>hbox</layout>
        <default-padding>2</default-padding>
        <stretch>true</stretch>
        <halign>fill</halign>
        <valign>fill</valign>

        <empty><stretch>1</stretch></empty>

        <button>
            <legend>Add Selected</legend>
            <equal>true</equal>
            <enable>
                <greater-than>
                <property>/sim/gui/dialogs/flight-planner/selection_srch</property>
                <value>-1</value>
                </greater-than>
            </enable>
            <binding>
                <command>nasal</command>
                <script>insert()</script>
            </binding>
        </button>

        <!-- gap -->
        <text>
          <label> </label>
        </text>
    </group>

    <hrule/>

    <!-- button field -->
    <group>
        <layout>hbox</layout>
        <halign>fill</halign>
        <default-padding>8</default-padding>

        <button>
            <legend>Load...</legend>
            <equal>true</equal>
            <binding>
                <command>nasal</command>
                <script>load_route();</script>
            </binding>
        </button>

        <button>
            <legend>Save...</legend>
            <equal>true</equal>
            <binding>
                <command>nasal</command>
                <script>save_route();</script>
            </binding>
        </button>

        <vrule/>

        <button>
            <legend>Send to Route Manager</legend>
            <default>true</default>
            <binding>
                <command>nasal</command>
                <script>pushToRM();</script>
            </binding>
        </button>
        <text>
            <label>(e.g. show on map)</label>
            <halign>right</halign>
        </text>

        <vrule/>

        <empty><stretch>1</stretch></empty>

        <button>
            <legend>Close</legend>
            <default>true</default>
            <key>Esc</key>
            <binding>
                <command>dialog-close</command>
            </binding>
        </button>
    </group>
</PropertyList>